#define led0_pin   PIN_B7
#define led1_pin   PIN_B6
//#define test_pin   PIN_A5

void a(){
output_bit(led0_pin, !(input(led0_pin)));
}
void a_h(){
output_bit(led0_pin, 1);
}
void a_l(){
output_bit(led0_pin, 0);
}

void b(){
output_bit(led1_pin, !(input(led1_pin)));
}
void b_h(){
output_bit(led1_pin, 1);
}
void b_l(){
output_bit(led1_pin, 0);
}

void t(){
//output_bit(test_pin, !(input(test_pin)));
}
void t_h(){
//output_bit(test_pin, 1);
}
void t_l(){
//output_bit(test_pin, 0);
}



//#define led1_pin   PIN_A0
//#define led2_pin   PIN_B0
//#define led3_pin   PIN_B5

#byte INTCON = 0x0b

#byte PORTA  = 0x80
#byte PORTB  = 0x81

#byte PIR1   = 0xF9E // Peripheral Interrupt Request (flag) Register 1
//--------------------------------------------------------------------
#bit  RCIF   = PIR1.5
#bit  ADIF   = PIR1.6

#byte PIR2   = 0xFA1 // Peripheral Interrupt Request (flag) Register 2
//--------------------------------------------------------------------
#bit  TMR3IF = PIR2.1

#byte RCREG  = 0xFAE // EUSART Receive Register
//---------------------------------------------

#byte TXSTA  = 0xFAC // EUSART TRANSMIT STATUS AND CONTROL REGISTER
//-----------------------------------------------------------------
#bit  CSRC   = TXSTA.7 // Clock Source select bit
#bit  TX9    = TXSTA.6 // 9-bit Transmit Enable Bit
#bit  TXEN   = TXSTA.5 // Transmit Enable bit
#bit  SYNC   = TXSTA.4 // EUSART mode select bit
#bit  SENB   = TXSTA.3 // Send Break Character bit
#bit  BRGH   = TXSTA.2 // High Baud Rate Select bit
#bit  TRMT   = TXSTA.1 // Transmit Shift Register Status bit
#bit  TX9D   = TXSTA.0 // 9th bit of Transmit Data


#byte RCSTA = 0xFAB // EUSART RECEIVE STATUS AND CONTROL REGISTER
//--------------------------------------------------------------
#bit  SPEN  = RCSTA.7 // [1] Serial Port Enable bit
#bit  RX9   = RCSTA.6 // [0] 9-bit Receive Enable bit
#bit  SREN  = RCSTA.5 // [*] Single Receive Enable bit 
#bit  CREN  = RCSTA.4 // [1] Continuous Receive Enable bit
#bit  ADDEN = RCSTA.3 // [0] Address Detect Enable bit
#bit  FERR  = RCSTA.2 // [0] Framing Error bit
#bit  OERR  = RCSTA.1 // [0] Overrun Error bit
#bit  RX9D  = RCSTA.0 // [0] 9th bit of Reived Data

#byte SPBRGH = 0xFB0 // EUSART BAUD RATE GENERATOR REGISTER HIGH BYTE
//-------------------------------------------------------------------

#byte SPBRG  = 0xFAF // EUSART BAUD RATE GENERATOR REGISTER LOW BYTE
//------------------------------------------------------------------

#byte BAUDCTL  = 0xFAA // EUSART BAUD RATE CONTROL REGISTER
//---------------------------------------------------------
#bit  RCIDL  = BAUDCTL.6 // Receive Operation Idle Status bit
#bit  SCKP   = BAUDCTL.4 // Synchronous Clock Polarity bit
#bit  BRG16  = BAUDCTL.3 // 16 bit Baud rate register enable bit
#bit  WUE    = BAUDCTL.1 // Wake up enable bit
#bit  ABDEN  = BAUDCTL.0 // Auto baud detect enable bit

//PWM 10 bit duty word: <CCPR1L><CCP1CON 5, 4>
#byte CCPR1L = 0xFBE  //p119
//--------------------------

#byte CCP1CON = 0xFBD
//-------------------
#bit DC1B0 = CCP1CON.4
#bit DC1B1 = CCP1CON.5

//------------------------------------------------------------------------------

// ADC
#byte ADRESH = 0xFC4 //ADC Result Register high Byte
//--------------------------------------------------

#byte ADRESL = 0xFC3 //ADC Result Register low Byte
//-------------------------------------------------

#byte ADCON0 = 0xFC2 //A/D control register 0
//-------------------------------------------
#bit VCFG1   = ADCON0.7 // Voltage Reference Configuration
#bit VCFG0   = ADCON0.6 // Voltage Reference Configuration
//unimplemented
#bit CHS2    = ADCON0.4 // Channel Select
#bit CHS1    = ADCON0.3 // Channel Select
#bit CHS0    = ADCON0.2 // Channel Select
#bit GO_DONE = ADCON0.1 // Start conversion. 1 = busy, 0 = done
#bit ADON    = ADCON0.0 // ADC enable

#byte ADCON1 = 0xFC1 //A/D control register 1
//-------------------------------------------
//unimplemented
#bit PCFG6 = ADCON1.6 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG5 = ADCON1.5 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG4 = ADCON1.4 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG3 = ADCON1.3 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG2 = ADCON1.2 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG1 = ADCON1.1 // Port configuration bit (1 = digital, 0 = analog)
#bit PCFG0 = ADCON1.0 // Port configuration bit (1 = digital, 0 = analog)

#byte ADCON2= 0xFC0 //A/D control register 2
//------------------------------------------
#bit ADFM  = ADCON2.7 // 
//unimplemented
#bit ACQT2 = ADCON2.5 // A/D Acquisition Time Select bit
#bit ACQT1 = ADCON2.4 // A/D Acquisition Time Select bit
#bit ACQT0 = ADCON2.3 // A/D Acquisition Time Select bit
#bit ADCS2 = ADCON2.2 // A/D Conversion Clock Select bit
#bit ADCS1 = ADCON2.1 // A/D Conversion Clock Select bit
#bit ADCS0 = ADCON2.0 // A/D Conversion Clock Select bit

//------------------------------------------------------------------------------

int8 pot0 = 0;
int8 pot1 = 0;
int8 pot2 = 0;
int8 pot3 = 0;
int8 pot4 = 0;
int8 pot5 = 0;

int8 pot0_old = 0;
int8 pot1_old = 0;
int8 pot2_old = 0;
int8 pot3_old = 0;
int8 pot4_old = 0;
int8 pot5_old = 0;

int8 pot0_debounce_cntr = 0;
int8 pot1_debounce_cntr = 0;
int8 pot2_debounce_cntr = 0;
int8 pot3_debounce_cntr = 0;
int8 pot4_debounce_cntr = 0;
int8 pot5_debounce_cntr = 0;

//int1 pot0_changed = 0;
//int1 pot1_changed = 0;
//int1 pot2_changed = 0;
//int1 pot3_changed = 0;
//int1 pot4_changed = 0;
//int1 pot5_changed = 0;


 

int1 DCAenv_changed = 0;
int1 DCFenv_changed = 0;

int1 DCAenv_changed_led = 0;
int1 DCFenv_changed_led = 0;

//int16 zx;
//int1 zxx=0;

int1 Gate = 0;
//int1 Gate_prev = 0;

//int1 all_midi_channels = 0;

int8 dp = 0;


////////////////////////////////////////////////////////////////////////////////
//If you want the full 16-bit result from int8 * int8, you can use this (written for the 18F2220): 

#byte PRODH = 0xff4 // HW multiply result MSB
#byte PRODL = 0xff3 // HW multiply result LSB
// MULT macro
// Performs 8x8 hardware multiply of x and y and stores the 16-bit
// result in xy
#define MULT(x,y,xy) \
#asm \
movf x,w \
mulwf y \
#endasm \
xy = MAKE16(PRODH,PRODL); 

//Now just write MULT(arg1,arg2,result) when you want to multiply two int8 variables named arg1 and arg2 and store the product in int16 result. 
////////////////////////////////////////////////////////////////////////////////
// multiply 8 bit x & y, return only msb of result as x


#byte PRODH = 0xff4 // HW multiply result MSB
#byte PRODL = 0xff3 // HW multiply result LSB
// MULT macro
// Performs 8x8 hardware multiply of x and y and stores the 16-bit
// result in xy
#define MUL(x,y) \
#asm \
movf x,w \
mulwf y \
#endasm \
x = PRODH;


int8 mx(int8 x, y){
#byte PRODH = 0xff4 // HW multiply result MSB
#byte PRODL = 0xff3 // HW multiply result LSB
#asm \
movf x,w \
mulwf y \
#endasm \
return(PRODH);
}

/////////////////////////
int8 demo_delay = 0;
int8 demo_filter = 0;
int8 demo_filter_dir = 1;
//int8 demo_wavlet_0 = 0;
//int8 demo_wavlet_1 = 0;
//int8 demo_wavlet_2 = 0;
//int8 demo_wavlet_3 = 0;
int8 demo_wave = 0;
/////////////////////////


int1 DEMO = 0;

int1 env_amp_sust = 0;
int1 env_amp_retrig = 0;
int1 env_filt_sust = 0;
int1 env_filt_retrig = 0;
int1 vel_filt = 0; // filter level determined by MIDI velocity
int1 glide = 0;   // note glide


////////////////////////////////////////////////////////////////////////////////

//LFO
int16 LFOphase;
//int8 _LFO, LFO,vb = 0;
int8 DCF_LFO_next, DCF_LFO_now = 0;

int1 zero = 0;
