
#include "D:\MY_STUFF\My Projects\mySynth\PIC\main.h"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\var.c"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\LUT.c"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\midi.c"

#include "D:\MY_STUFF\My Projects\mySynth\PIC\envelopes.c"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\sub_osc.c"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\DCO.c"
#include "D:\MY_STUFF\My Projects\mySynth\PIC\UI.c"



int8 x = 0;
int1 DoStuff=0;



int8 env_pre_scaler;

// -- TIMER0 Interrupt handler -------------------------------------------------

#INT_RTCC high // OSC1
void t0_isr(){
   osc_thread();
   midi_thread();
   
   if (TMR3IF){    
     set_timer3(get_timer3() + 60500);
      DoStuff = true;
      TMR3IF = 0;      
   }
   set_timer0(get_timer0() + osc1_delay);
}

// -----------------------------------------------------------------------------

void Stuff(){
   DoStuff = false;
   UI_thread();

   /* LED ON POT CHANGE EVENT */
   if (DCAenv_changed_led || DCFenv_changed_led){
      DCAenv_changed_led = 0;
      DCFenv_changed_led = 0;
      x = 100;
   }
   if (x>0)x--;
   output_bit(led1_pin, (x>0));

   if (env_pre_scaler > 0) env_pre_scaler--;
   else{
      env_pre_scaler = 10;
      DCAenv_thread();
      DCFenv_thread();
      LFO_knot();
   }
   
   // Demo
   if (DEMO){
   if (demo_delay == 0){
      demo_delay = 10;
 
  if (demo_filter_dir == 1) demo_filter++;
      else demo_filter--;
   
      if (demo_filter == 255) demo_filter_dir = 0;
      if (demo_filter == 0){
         demo_filter_dir = 1;
      
         
         demo_wave++;
         if (demo_wave > 9) demo_wave = 0;
         
         switch (demo_wave){
          case 0 : goto demo_wav_0;
          case 1 : goto demo_wav_1;
          case 2 : goto demo_wav_2;
          case 3 : goto demo_wav_3;
          case 4 : goto demo_wav_4;
          case 5 : goto demo_wav_5;
          case 6 : goto demo_wav_6;
          case 7 : goto demo_wav_7;
          case 8 : goto demo_wav_8;
          case 9 : goto demo_wav_9;
     }

demo_wav_0:
      wavlet[0] = wsquare;
      wavlet[1] = wsquare;
      wavlet[2] = wsquare;
      wavlet[3] = wsquare;
   goto demo_done;
   
demo_wav_1:
      wavlet[0] = wsaw0;
      wavlet[1] = wsaw1;
      wavlet[2] = wsaw1;
      wavlet[3] = wsaw0;

   goto demo_done;
   
demo_wav_2:
      wavlet[0] = wpulse;
      wavlet[1] = wpulse;
      wavlet[2] = wpulse;
      wavlet[3] = wpulse;

   goto demo_done;
   
demo_wav_3:
      wavlet[0] = wpole;
      wavlet[1] = wpole;
      wavlet[2] = wpole;
      wavlet[3] = wpole;
   goto demo_done;
   
demo_wav_4:
      wavlet[0] = wpole;
      wavlet[1] = wdouble;
      wavlet[2] = wdouble;
      wavlet[3] = wpole;
   goto demo_done;
   
demo_wav_5:
      wavlet[0] = wpole;
      wavlet[1] = wpulse;
      wavlet[2] = wpulse;
      wavlet[3] = wpole;
   goto demo_done;
   
demo_wav_6:
      wavlet[0] = wsaw0;
      wavlet[1] = wpulse;
      wavlet[2] = wpulse;
      wavlet[3] = wsaw0;
   goto demo_done;
   
demo_wav_7:
      wavlet[0] = wsaw1;
      wavlet[1] = wSquare;
      wavlet[2] = wsquare;
      wavlet[3] = wsaw1;

   goto demo_done;
   
demo_wav_8:
      wavlet[0] = wdouble;
      wavlet[1] = wdouble;
      wavlet[2] = wdouble;
      wavlet[3] = wdouble;
   goto demo_done;
   
demo_wav_9:
      wavlet[0] = wdouble;
      wavlet[1] = wsaw1;
      wavlet[2] = wsaw1;
      wavlet[3] = wdouble;
   goto demo_done;

demo_done:
   ;
      };
      }
   else demo_delay--;
   
   
   };
   
}

//------------------------------------------------------------------------------

void InitPorts(){

   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1); //OSC1
   //setup_timer_2(T2_DIV_BY_1, 0x3F, 1);  //8 bit
   setup_timer_2(T2_DIV_BY_1, 0xFF, 1);   //10 bit
   setup_timer_3(T3_INTERNAL|T3_DIV_BY_1); //OSC1
   
   // PWM
   setup_ccp1(CCP_PWM);   // Configure CCP1 as a PWM
   set_pwm1_duty(100);
      
   enable_interrupts(INT_TIMER0);   
   enable_interrupts(GLOBAL);
   
   port_b_pullups(FALSE);
   
   set_tris_a (0b11101111);
   set_tris_b (0b00010011); 
}

//------------------------------------------------------------------------------

void main(){

   InitPorts();
 
 // turn off leds
   output_bit(led0_pin, 0);
   output_bit(led1_pin, 0);

   update_DCAenv();
   update_DCFenv();
   init_midi();
   init_adc();

   /* Init Oscillator */
//   Gate=0;
//   mTrigger = 0;
   
   wavlet[0] = wsquare;
   wavlet[1] = wsquare;
   wavlet[2] = wsquare;
   wavlet[3] = wsquare;

loop:
 if (DoStuff == true)Stuff();
 if (DoNote == true){DoNote = false; Note(mNote_next); mNote_now = mNote_next;}
 if (DCAenv_changed){DCAenv_changed_led = 1; update_DCAenv();}
 if (DCFenv_changed){DCFenv_changed_led = 1; update_DCFenv();}
 
//DCFenv_S=255; //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
//output_bit(led0_pin, env_amp_sust);
//output_bit(led0_pin, env_amp_retrig); 


//output_bit(led0_pin, env_filt_sust);
//output_bit(led0_pin, env_filt_retrig);
 
//output_bit(led0_pin, vel_filt);
//output_bit(led0_pin, glide);
 

//output_bit(led0_pin, (midi_my_channel == 11)); 
 
   goto loop;
}

//------------------------------------------------------------------------------
